// module: QuickSort.java
// auteur: felipe 
// objet:  une version possible du quick sort
//         illustration++ de la recursivite

public class QuickSort {

  final static int TAILLE = 1000;  // une constante

  // deja vu: echange de deux elements d'un tableau

  static void swap(int tab[], int a, int b) { // deja vu
    int tmp = tab[a];
    tab[a] = tab[b];
    tab[b] = tmp;
  }

  // choisir un pivot, mettre a gauche les valeurs inferieures, 
  // a droite, les valeurs superieures (au pivot)
  // ici le pivot est le premier element de la table
  // ce qui n'est probablement pas optimal !	
 
  static int partitionne(int table[], int deb, int fin) {
    while (deb < fin) { // passe de droite vers la gauche
      while ((deb < fin) && (table[fin] >= table[deb])) fin--;
      if (deb < fin) { // permute puis commence une boucle dans l'autre sens
        swap(table,deb,fin);
        deb++;
        while ((deb<fin) && (table[deb] <= table[fin])) deb++;
        if (deb<fin) {
          swap(table,deb,fin);
          fin--;
          }
        }
    }
    return deb;
  }

  // tri: ecriture recursive ici

  static void quickSort(int []table, int deb, int fin) {

    if (deb < fin) { // test de continuite 
      int i = partitionne(table,deb,fin);
      quickSort(table,deb,i-1);
      quickSort(table,i+1,fin);
    }

  }

  // ---------------------------------------------------------------------
  // Jeux de main, jeux de vilain (exemple de commentaire stupide)
  // ---------------------------------------------------------------------

  public static void main(String args []) {

    int [] table = new int [TAILLE];

    // initialisation avec des valeurs entre 0 et 1000 (non inclus)
    for (int i=0; i<TAILLE; i++)
      table[i] = (int) (Math.random()*1000.);

    // affichage de la table (avant le tri)
    for (int i=0; i < TAILLE; i++) System.out.print(" " +table[i]);
    System.out.println();

    // tri de tous les elements de la table
    quickSort(table,0,table.length-1);

    // affichage de la table (cette fois-ci triee) 
    for (int i=0; i < TAILLE; i++) System.out.print(" " +table[i]);
    System.out.println(); 
  }
}
